-----------------------------------------Full Adder (32-bit)---------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY adder_32bit IS
	PORT(
		a_in 		: IN STD_LOGIC_VECTOR(31 DOWNTO 0);		--1st operand									
		b_in 		: IN STD_LOGIC_VECTOR(31 DOWNTO 0);		--2nd operand									
		c_in 		: IN STD_LOGIC;								--Carry in (maybe from prev. stage)	
		result 	: OUT STD_LOGIC_VECTOR(31 DOWNTO 0);	--Result 							
		c_out 	: OUT STD_LOGIC								--Carry out (for Program Status Register [PSR])
	);
END adder_32bit;

ARCHITECTURE adder_32bit_Imp1 OF adder_32bit IS
	COMPONENT fullAdder IS											--create component to use fullAdder class
		PORT (
			a		: IN std_logic;
			b		: IN std_logic;
			cin	: IN std_logic;
			sum	: OUT std_logic;
			cout	: OUT  std_logic
		);
	END COMPONENT;
	SIGNAL wire: std_logic_vector(30 downto 0);
BEGIN																		--p1 is object of type fullAdder
	p1:  fullAdder PORT MAP(a_in(0),b_in(0),c_in,result(0),wire(0));		--0th wire of a_in mapped to 'a' input, 0th wire of b_in mapped to 'b' input
	p2:  fullAdder PORT MAP(a_in(1),b_in(1),wire(0),result(1),wire(1));	--wire(0) connect to cout (since feeds back into cin of next compo.)
	p3:  fullAdder PORT MAP(a_in(2),b_in(2),wire(1),result(2),wire(2));
	p4:  fullAdder PORT MAP(a_in(3),b_in(3),wire(2),result(3),wire(3));
	p5:  fullAdder PORT MAP(a_in(4),b_in(4),wire(3),result(4),wire(4));
	p6:  fullAdder PORT MAP(a_in(5),b_in(5),wire(4),result(5),wire(5));
	p7:  fullAdder PORT MAP(a_in(6),b_in(6),wire(5),result(6),wire(6));
	p8:  fullAdder PORT MAP(a_in(7),b_in(7),wire(6),result(7),wire(7));
	p9:  fullAdder PORT MAP(a_in(8),b_in(8),wire(7),result(8),wire(8));
	p10: fullAdder PORT MAP(a_in(9),b_in(9),wire(8),result(9),wire(9));
	p11: fullAdder PORT MAP(a_in(10),b_in(10),wire(9),result(10),wire(10));
	p12: fullAdder PORT MAP(a_in(11),b_in(11),wire(10),result(11),wire(11));
	p13: fullAdder PORT MAP(a_in(12),b_in(12),wire(11),result(12),wire(12));
	p14: fullAdder PORT MAP(a_in(13),b_in(13),wire(12),result(13),wire(13));
	p15: fullAdder PORT MAP(a_in(14),b_in(14),wire(13),result(14),wire(14));
	p16: fullAdder PORT MAP(a_in(15),b_in(15),wire(14),result(15),wire(15));
	p17: fullAdder PORT MAP(a_in(16),b_in(16),wire(15),result(16),wire(16));
	p18: fullAdder PORT MAP(a_in(17),b_in(17),wire(16),result(17),wire(17));
	p19: fullAdder PORT MAP(a_in(18),b_in(18),wire(17),result(18),wire(18));
	p20: fullAdder PORT MAP(a_in(19),b_in(19),wire(18),result(19),wire(19));
	p21: fullAdder PORT MAP(a_in(20),b_in(20),wire(19),result(20),wire(20));
	p22: fullAdder PORT MAP(a_in(21),b_in(21),wire(20),result(21),wire(21));
	p23: fullAdder PORT MAP(a_in(22),b_in(22),wire(21),result(22),wire(22));
	p24: fullAdder PORT MAP(a_in(23),b_in(23),wire(22),result(23),wire(23));
	p25: fullAdder PORT MAP(a_in(24),b_in(24),wire(23),result(24),wire(24));
	p26: fullAdder PORT MAP(a_in(25),b_in(25),wire(24),result(25),wire(25));
	p27: fullAdder PORT MAP(a_in(26),b_in(26),wire(25),result(26),wire(26));
	p28: fullAdder PORT MAP(a_in(27),b_in(27),wire(26),result(27),wire(27));
	p29: fullAdder PORT MAP(a_in(28),b_in(28),wire(27),result(28),wire(28));
	p30: fullAdder PORT MAP(a_in(29),b_in(29),wire(28),result(29),wire(29));
	p31: fullAdder PORT MAP(a_in(30),b_in(30),wire(29),result(30),wire(30));
	p32: fullAdder PORT MAP(a_in(31),b_in(31),wire(30),result(31),c_out);			--cout is last "wire" out
END adder_32bit_Imp1;