-----------------------------------------Full Adder-----------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY fullAdder IS
	PORT(
			a	 		: IN STD_LOGIC;		--1st operand									
			b	 		: IN STD_LOGIC;		--2nd operand									
			cin 		: IN STD_LOGIC;		--Carry in (maybe from prev. stage)	
			sum 		: OUT STD_LOGIC;		--Result 							
			cout 		: OUT STD_LOGIC		--Carry out (for Program Status Register [PSR])	
	);
END fullAdder;

ARCHITECTURE fullAdder_Imp1 OF fullAdder IS		--any of input change, output change same time
BEGIN															--no process
	sum <= (a XOR b) XOR cin;
	cout <= (a AND b) OR ((a XOR b) AND cin);

END fullAdder_Imp1;