-----------------------------------------MUX (2to1)-----------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY mux_2to1 IS
	PORT(
		in0,in1		: IN STD_LOGIC_VECTOR(31 downto 0);	--MUX signal input choices										
		sel 			: IN STD_LOGIC;							--Select		(1-bit)							
		y 			   : OUT STD_LOGIC_VECTOR(31 downto 0)	--MUX output signal	
	);
END mux_2to1;

ARCHITECTURE description OF mux_2to1 IS		
BEGIN															
	PROCESS(sel,in0,in1)
	BEGIN
		CASE sel IS																
			WHEN '0' => y <= in0;		--Send 0 signal to output
			WHEN '1' => y <= in1;		--Send 1 signal to output
			WHEN others => y <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ"; --disconnected for other options
		END CASE;
	END PROCESS;
END description;