-----------------------------------------MUX (4to1)-----------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY mux_4to1 IS
	PORT(
		in0,in1,in2,in3							: IN STD_LOGIC_VECTOR(31 downto 0);	--MUX signal input choices										
		sel 											: IN STD_LOGIC_VECTOR(1 downto 0);	--Select									
		y 												: OUT STD_LOGIC_VECTOR(31 downto 0)	--MUX output signal	
	);
END mux_4to1;

ARCHITECTURE description OF mux_4to1 IS		
BEGIN															
	PROCESS(sel,in0,in1,in2,in3)
	BEGIN
		CASE sel IS							--For the differenet cases of sel values
			WHEN "00" => y <= in0;		--Send 0 signal to output
			WHEN "01" => y <= in1;		--Send 1 signal to output
			WHEN "10" => y <= in2;		--Send 2 signal to output
			WHEN "11" => y <= in3;		--Send 3 signal to output
			WHEN others => y <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ"; -- for rest of possible options
		END CASE;
	END PROCESS;
END description;