-----------------------------------------MUX (8to1)-----------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY mux_8to1 IS
	PORT(
		in0,in1,in2,in3,in4,in5,in6,in7		: IN STD_LOGIC_VECTOR(31 downto 0);	--MUX signal input choices										
		sel 											: IN STD_LOGIC_VECTOR(2 downto 0);	--Select									
		y 												: OUT STD_LOGIC_VECTOR(31 downto 0)	--MUX output signal	
	);
END mux_8to1;

ARCHITECTURE muxImplementation OF mux_8to1 IS		
BEGIN															
	PROCESS(sel,in0,in1,in2,in3,in4,in5,in6,in7)
	BEGIN
		CASE sel IS																--For the differenet cases of sel values
			WHEN "000" => y <= in0;		--Send 0 signal to output
			WHEN "001" => y <= in1;		--Send 1 signal to output
			WHEN "010" => y <= in2;		--Send 2 signal to output
			WHEN "011" => y <= in3;		--Send 3 signal to output
			WHEN "100" => y <= in4;		--Send 4 signal to output
			WHEN "101" => y <= in5;		--Send 5 signal to output
			WHEN "110" => y <= in6;		--Send 6 signal to output
			WHEN "111" => y <= in7;		--Send 7 signal to output
			WHEN others => y <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ"; -- for rest of possible options
		END CASE;
	END PROCESS;
END muxImplementation;