----------------------------------------Program Counter (32-bits)-----------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;

ENTITY pc IS
	PORT(
		clr : IN STD_LOGIC;
		clk : IN STD_LOGIC;
		ld : IN STD_LOGIC;
		inc : IN STD_LOGIC;
		d : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		q : INOUT STD_LOGIC_VECTOR(31 DOWNTO 0)
		);
END pc;

ARCHITECTURE description OF pc IS
BEGIN
	PROCESS (clk,clr)
	BEGIN
		IF clr = '1' THEN								
			q <= (others => '0');					
		ELSIF  clk'event AND clk = '1' THEN		 
			IF ld = '1' THEN	
				IF inc = '1' THEN							
					q <= q + 1;
				ELSIF inc = '0' THEN
					q <= d;
				END IF;
			END IF;										
		END IF;
	END PROCESS;
END description;

-- ld signal used to tell PC it wants to execute specific instruction from specific location
-- EX: 1st instruction stored in x0009 (start counting from THAT location) (ld=1, then give d=x0009)
--		 Once set that up, can remove the ld and d signal. At next clk cycle (when have taken instruction and executed it)
--		 Next instruction should be at x0009+4=x000D (therefore don't have to load address again)
--     Just put inc=1 (it knows previous value), generate new address and give it to Instruction Memory 