----------------------------------------1-bit Register------------------------------------------------------------
LIBRARY ieee ;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;
ENTITY register1 IS
	PORT (
			d : IN STD_LOGIC;						--SW[2]			input
			ld : IN STD_LOGIC;					--SW[3]			load/enable
			clk : IN STD_LOGIC;					--SW[0]			async. clear
			clr : IN STD_LOGIC;					--SW[1]			clock
			Q : OUT STD_LOGIC						--LEDG[0]		output
			);
END register1;

ARCHITECTURE description OF register1 IS
BEGIN
	PROCESS (clk,clr) 							-- below cases are based (controlled by signals clk and clr)
	BEGIN 
		IF clr = '1' THEN 						-- if clk is enabled, output (Q) is 0
			Q <= '0';
		ELSIF clk'event AND clk = '1' THEN 	-- at the rising edge of the clk pulse
			IF ld = '1' THEN						-- if ld=1
				Q <= d;								-- Q gets the value of input signal d
			END IF;									-- else (ld=0), Q remains at previous value stored
		END IF;
	END PROCESS;
END description;