---------------------------------------32-bit Register------------------------------------------------------------
LIBRARY ieee ;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;
ENTITY register32 IS
	PORT (
			d : IN STD_LOGIC_VECTOR(31 DOWNTO 0);				--input
			ld : IN STD_LOGIC;										--load/enable
			clk : IN STD_LOGIC;										--async. clear
			clr : IN STD_LOGIC;										--clock
			Q : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)				--output
			);
END register32;

ARCHITECTURE description OF register32 IS
BEGIN
	PROCESS (clk,clr) 							-- below cases are based (controlled by signals clk and clr)
	BEGIN 
		IF clr = '1' THEN 						-- if clk is enabled, output (Q) is 0
			Q <= (others => '0');				-- 'others' -> all bits in Q get 0 (since 32 0s a lot to type)
		ELSIF clk'event AND clk = '1' THEN 	-- at the rising edge of the clk pulse
			IF ld = '1' THEN						-- if ld=1
				Q <= d;								-- Q gets the value of input signal d
			END IF;									-- else (ld=0), Q remains at previous value stored
		END IF;
	END PROCESS;
END description;	